#
# spec file for package perl-MCE-Shared
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           perl-MCE-Shared
Version:        1.840
Release:        1.1
%define cpan_name MCE-Shared
Summary:        MCE extension for sharing data supporting threads and processes
License:        Artistic-1.0 OR GPL-1.0-or-later
Group:          Development/Libraries/Perl
Url:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/M/MA/MARIOROY/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(IO::FDPass) >= 1.2
BuildRequires:  perl(MCE) >= 1.837
BuildRequires:  perl(Test::More) >= 0.88
Requires:       perl(IO::FDPass) >= 1.2
Requires:       perl(MCE) >= 1.837
Recommends:     perl(IO::FDPass) >= 1.2
Recommends:     perl(Sereal::Decoder) >= 3.015
Recommends:     perl(Sereal::Encoder) >= 3.015
%{perl_requires}

%description
This module provides data sharing capabilities for MCE supporting threads
and processes. MCE::Hobo provides threads-like parallelization for running
code asynchronously.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%check
make test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README.md
%license Copying LICENSE

%changelog
* Fri Jan  4 2019 coolo@suse.com
- updated to 1.840
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.840 Thu Jan 03 23:30:00 EST 2019
  * Improved destroy and exit cleanup in MCE::Shared::Server.
* Thu Sep 20 2018 coolo@suse.com
- updated to 1.839
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.839 Sat Aug 25 13:00:00 EST 2018
  * Seeds the Math::Random::MT::Auto generator automatically when present
    in MCE::Hobo, similarly to Math::Random and Math::Prime::Util, to avoid
    child processes sharing the same seed value as the parent and each other.
    The new seed is computed using the current seed.
  * Updated MCE::Shared::Cache to support optional argument "expires_in" for
    set and sugar methods.
  * Updated MCE::Shared documentation.
  * Bumped MCE dependency to 1.837.
* Tue Jul 17 2018 coolo@suse.com
- updated to 1.838
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.838 Mon Jun 25 22:00:00 EST 2018
  * Fixed exporting deeply-shared regressions.
  1.837 Mon Jun 25 08:30:00 EST 2018
  * Fixed deeply-shared regressions. Thank you, PerlMonks (Veltro).
    See https://perlmonks.pairsite.com/?node_id=1216790.
  * Applied small optimizations.
  * Bumped MCE dependency to 1.836.
* Wed Apr 11 2018 coolo@suse.com
- updated to 1.836
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.836 Tue Mar 13 15:00:00 EST 2018
  * Added chameneos demonstration to MCE::Shared::Condvar.
  * Load IO::Handle for extra stability, preventing workers loading uniquely.
  * Load Net::HTTP and Net::HTTPS before spawning if present LWP::UserAgent.
    See http://www.perlmonks.org/?node_id=1199760
    and http://www.perlmonks.org/?node_id=1199891.
  * Bumped MCE dependency to 1.835.
* Wed Feb  7 2018 coolo@suse.com
- updated to 1.835
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.835 Tue Jan 23 08:00:00 EST 2018
  * Added max_workers method to MCE::Hobo.
  * Improved Queue await and dequeue performance on the Windows platform.
  * Added chameneos-redux parallel demonstrations on Github:
    https://github.com/marioroy/mce-examples/tree/master/chameneos
  * Bumped MCE dependency to 1.834.
* Sat Dec 16 2017 coolo@suse.com
- updated to 1.834
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.834 Fri Dec 15 15:30:00 EST 2017
  * Fixed croak handling inside MCE::Shared::Server.
  * Enhanced sequence (bounds_only) to return optional 3rd value (id).
  * Improved seconds method for _delay package inside MCE::Hobo.
  * Improved clear and get methods for shared objects.
  * Tweeked shared_cache_lru test script.
* Mon Dec 11 2017 coolo@suse.com
- updated to 1.833
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.833 Tue Nov 21 15:30:00 EST 2017
  * Condvar timedwait supports floating seconds via Time::HiRes.
    The documentation was correct, but not high resolution in code.
  * Added LWP::UserAgent to list for enabling posix_exit.
  * Improved number-sequence generation for big integers.
  * Improved exiting (CLOSE, DESTROY) during cleanup state.
  * Improved signal handling when server is waiting on IO.
  * Updated "OBJECT SHARING" section in documentation.
  * Bumped MCE dependency to 1.832.
* Tue Oct 10 2017 coolo@suse.com
- updated to 1.832
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.832 Sun Oct 08 20:30:00 EST 2017
  * Added STFL (Terminal UI) to list for enabling posix_exit.
    See http://www.perlmonks.org/?node_id=1200923.
  * Math::Prime::Util random numbers now unique between Hobo workers.
    See http://www.perlmonks.org/?node_id=1200960.
  * Bumped MCE dependency to 1.831.
* Thu Sep 21 2017 coolo@suse.com
- updated to 1.831
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.831 Tue Sep 19 23:00:00 EST 2017
  * Resolved crash on the Windows platform for older Perl (< v5.18).
    Older Perl must continue to run the shared-server as a thread.
    Thank you CPAN testers, CHORNY and NONAME.
  * Re-enabled Condvar testing on the Windows platform.
* Mon Sep 18 2017 coolo@suse.com
- updated to 1.830
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.830 Fri Sep 15 23:00:00 EST 2017
  * Disabled Condvar tests on the Windows platform. I'm unable to replicate
    the exit behavior reported by two smoke machines running Windows.
  1.829 Thu Sep 14 23:00:00 EST 2017
  * Disabled Condvar tests on Windows machine without IO::FDPass.
* Thu Sep 14 2017 coolo@suse.com
- updated to 1.828
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.828 Wed Sep 12 23:00:00 EST 2017
  * Removed extra "=over" command in documentation.
  1.827 Tue Sep 12 17:00:00 EST 2017
    [BUG FIXES]
  * Fixed bug in MCE::Shared::Queue. Thank you, Tomohiro Hosaka.
    [ENHANCEMENTS]
  * Refactored MCE::Hobo, MCE::Shared, and MCE::Shared::Server.
  * Preserve lexical type for numbers during IPC.
  * Added Coro and Win32::GUI to list for enabling posix_exit.
  * Added encoder and decoder methods for overriding serialization.
  * Added parallel HTTP get demonstration using AnyEvent to MCE::Hobo.
  * Added Inline::Python, Logger, and Tie::File demonstrations to MCE::Shared.
  * Added DBM-Sharing section to the POD documentation.
  * Added iterator method to MCE::Cache.
  * Improved auto-dereferencing for shared arrays, hashes, and scalars.
  * Improved open method for non-shared file-handles in MCE::Shared::Handle.
  * Improved shared-PDL support. Updated MCE::Cookbook on Github.
  * Improved signal handling, including nested parallel-sessions.
  * Improved running MCE::Hobo and MCE::Shared with PDL.
  * Improved taint mode via perl -T.
  * In MCE::Hobo, waitall and waitone are now aliases to wait_all and
    wait_one respectively for backwards compatibility.
  * No longer loads threads on the Windows platform in MCE::Shared::Server.
    This enables MCE::Hobo to spin faster, including lesser memory consumption.
    Threads isn't required to run MCE::Hobo.
  * Removed extra white-space from POD documentation.
  * Validated MCE::Hobo and MCE::Shared on SmartOS.
  * Bumped MCE dependency to 1.830.
* Thu May  4 2017 coolo@suse.com
- updated to 1.826
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.826 Wed May 03 03:00:00 EST 2017
  * Reduced memory consumption.
  * Clarified "limitations" section in MCE::Share::{ Condvar, Handle, Queue }.
    Clarified "extra functionality" section in MCE::Shared.
    Thank you, http://www.perlmonks.org/?node=zentara.
  * Bumped MCE dependency to 1.829.
* Sat Apr 29 2017 coolo@suse.com
- updated to 1.825
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.825 Fri Apr 28 16:00:00 EST 2017
    [BUG FIXES]
  * Do not enable barrier mode for Queue on the Windows platform.
  * Fixed MCE::Hobo on the Windows platform for older Perl < v5.16.
    [ENHANCEMENTS]
  * Added Curses and Prima to list for enabling the posix_exit option.
  * Added module option for using a class implicitly when tie'ing a variable.
  * Added unbless option when exporting a shared object. Thank you, Nick Tonkin.
  * Improved support for running MCE::Hobo on the NetBSD platform.
  * Enhanced IPC and signal handling. Reduced memory consumption.
  * Bumped MCE dependency to 1.828.
* Fri Apr  7 2017 coolo@suse.com
- updated to 1.824
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.824 Thu Apr 06 18:00:00 EST 2017
  * Fixed bug introduced in 1.818, syswrite data to a shared file handle.
  1.823 Wed Apr 05 01:30:00 EST 2017
  * Do not enable barrier mode in Queue if constructed inside a thread or
    for the fast => 1 option.
  * Fixed leaked handles during destruction; MCE::Shared::{ Condvar, Queue }.
  * Updated MCE::Shared to not croak when running Perl in taint mode via
    perl -T. Failing -T was MCE::Shared::{ Handle, Sequence, and Server }.
  * Bumped MCE dependency to 1.827.
* Mon Apr  3 2017 coolo@suse.com
- updated to 1.822
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.822 Sun Apr 02 23:00:00 EST 2017
  * Added line for starting the shared-manager in previous change log.
  * Is now safe running MCE::Hobo with the Wx GUI toolkit (wxWidgets).
  * Bumped MCE dependency to 1.826.
  1.821 Sun Apr 02 07:00:00 EST 2017
  * Updated MCE::Shared::Queue. The following provides a comparison
    for the enhancements made regarding IPC during 1.818 through 1.821,
    in order to run on machines having "many" cores. I ran with 12, 96,
    and 192 workers on an 8 core box.
    Shared queue, dequeue 100k items.
    my $Q = MCE::Shared->queue();
    [#] Must start the manager manually when IO::FDPass is missing.
    [#] This caveat applies to Condvar, Handle, and Queue.
    MCE::Shared->start() unless $INC{'IO/FDPass.pm'};
    $Q->enqueue( 1 .. 100000 );
    $Q->end();
    MCE->new(
    max_workers => 12, 96, or 192,
    user_func   => sub {
    while ( defined ( my $item = $Q->dequeue ) ) {
    ;
    }
    }
    )->run();
    MCE::Shared 1.821:  12 ~ 1.325 secs  96 ~ 5.206 secs  192 ~ 8.158 secs
    MCE::Shared 1.825:     ~ 0.913 secs     ~ 1.068 secs      ~ 1.560 secs
  * Results were captured on a fast 8 core system running CentOS Linux 7.
    The thing to take from this is that running many workers "no longer"
    results in up to 6.2x penalty regarding IPC.
  * When IO::FDPass is missing, croak with error if constructing a Condvar
    or Queue and forgotten to start the shared-manager process manually.
  * Bumped MCE dependency to 1.825.
* Sun Apr  2 2017 coolo@suse.com
- updated to 1.820
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.820 Sat Apr 01 01:00:00 EST 2017
  * Completed validation for running MCE on a box having 100+ cores.
  * Tuned the number of data-channels for IPC, similar to MCE.
  * Bumped MCE dependency to 1.824.
* Sat Apr  1 2017 coolo@suse.com
- updated to 1.819
  see /usr/share/doc/packages/perl-MCE-Shared/Changes
  1.819 Fri Mar 31 19:30:00 EST 2017
  * Calibrated the number of data-channels for IPC.
  * Bumped MCE dependency to 1.823.
  1.818 Fri Mar 31 11:00:00 EST 2017
  * Check for EINTR during sysread and syswrite.
  * Improved non-shared handles constructed with MCE::Shared::Handle.
  * Reap MCE::Hobo's from script exiting during development process.
  * Completed validation for using MCE::Shared with 200+ cores.
  * Bumped MCE dependency to 1.822.
* Sat Mar 25 2017 coolo@suse.com
- initial package 1.817
  * created by cpanspec 1.78.08
